//
// Generated by SwagGen
// https://github.com/yonaskolb/SwagGen
//

import Foundation
import JSONUtilities

public class PageSummary: JSONDecodable, JSONEncodable, PrettyPrintable {

    /** Unique identifier for the page. */
    public var id: String

    /** Unique path for the page. */
    public var path: String

    /** Title of the page. */
    public var title: String

    /** Identifier for of the page template to render this page. */
    public var template: String

    /** True if this page is static and doesn't have any dynamic content to load.

Static pages don't need to go back to the page endpoint to load page content
instead the page summary loaded with the sitemap should be enough to determine
the page template type and render based on this.
 */
    public var isStatic: Bool

    /** True if this page is a system page type.

**DEPRECATED** This property doesn't have any real use in client applications
anymore so shouldn't be used. It especially shouldn't be used to determine if
a page is static or not. Use the `isStatic` property instead.
 */
    public var isSystemPage: Bool

    /** Key used to lookup a known page. */
    public var key: String?

    public init(id: String, path: String, title: String, template: String, isStatic: Bool, isSystemPage: Bool, key: String? = nil) {
        self.id = id
        self.path = path
        self.title = title
        self.template = template
        self.isStatic = isStatic
        self.isSystemPage = isSystemPage
        self.key = key
    }

    public required init(jsonDictionary: JSONDictionary) throws {
        id = try jsonDictionary.json(atKeyPath: "id")
        path = try jsonDictionary.json(atKeyPath: "path")
        title = try jsonDictionary.json(atKeyPath: "title")
        template = try jsonDictionary.json(atKeyPath: "template")
        isStatic = try jsonDictionary.json(atKeyPath: "isStatic")
        isSystemPage = try jsonDictionary.json(atKeyPath: "isSystemPage")
        key = jsonDictionary.json(atKeyPath: "key")
    }

    public func encode() -> JSONDictionary {
        var dictionary: JSONDictionary = [:]
        dictionary["id"] = id
        dictionary["path"] = path
        dictionary["title"] = title
        dictionary["template"] = template
        dictionary["isStatic"] = isStatic
        dictionary["isSystemPage"] = isSystemPage
        if let key = key {
            dictionary["key"] = key
        }
        return dictionary
    }

    /// pretty prints all properties including nested models
    public var prettyPrinted: String {
        return "\(Swift.type(of: self)):\n\(encode().recursivePrint(indentIndex: 1))"
    }
}
