//
// Generated by SwagGen
// https://github.com/yonaskolb/SwagGen
//

import Foundation
import JSONUtilities

public class ProfileDetail: ProfileSummary {

    /** A map of watched itemIds => last watched position */
    public var watched: [String: Watched]

    /** A map of rated itemIds => rating out of 10 */
    public var rated: [String: Int]

    /** A map of bookmarked itemIds => created date */
    public var bookmarked: [String: Date]

    public init(id: String, name: String, isActive: Bool, pinEnabled: Bool, purchaseEnabled: Bool, marketingEnabled: Bool, segments: [String], watched: [String: Watched], rated: [String: Int], bookmarked: [String: Date], maxRatingContentFilter: ClassificationSummary? = nil, minRatingPlaybackGuard: ClassificationSummary? = nil) {
        self.watched = watched
        self.rated = rated
        self.bookmarked = bookmarked
        super.init(id: id, name: name, isActive: isActive, pinEnabled: pinEnabled, purchaseEnabled: purchaseEnabled, marketingEnabled: marketingEnabled, segments: segments, maxRatingContentFilter: maxRatingContentFilter, minRatingPlaybackGuard: minRatingPlaybackGuard)
    }

    public required init(jsonDictionary: JSONDictionary) throws {
        watched = try jsonDictionary.json(atKeyPath: "watched")
        rated = try jsonDictionary.json(atKeyPath: "rated")
        bookmarked = try jsonDictionary.json(atKeyPath: "bookmarked")
        try super.init(jsonDictionary: jsonDictionary)
    }

    public override func encode() -> JSONDictionary {
        var dictionary: JSONDictionary = [:]
        dictionary["watched"] = watched.encode()
        dictionary["rated"] = rated
        dictionary["bookmarked"] = bookmarked.encode()
        let superDictionary = super.encode()
        for (key, value) in superDictionary {
            dictionary[key] = value
        }
        return dictionary
    }
}
